local spleen_overrides = {
}

function used_spleen(itemid, quantity, usetext)
	local item = get_item_data_by_id(itemid)
	if item and item.name then
		if item.spleen then
			if not usetext:match("bad for your spleen.  That .- would cause it to rupture.<") and not usetext:match("You need to be at least level .- to use that item") then
		-- 		print("used spleen", quantity, printstr(item), usetext)
				if tonumber(item.spleen) then
					increase_daily_counter("spleen", tonumber(item.spleen) * quantity)
				else
					day["unknown spleen"] = "yes"
				end
			end
		end
	else
		day["unknown spleen"] = "yes"
		print("Unknown spleen item, id:", itemid)
	end
end

add_processor("/inv_use.php", function()
	used_spleen(tonumber(params.whichitem), tonumber(params.itemquantity) or 1, text)
end)

add_processor("/multiuse.php", function()
	if not params.whichitem then return end
	used_spleen(tonumber(params.whichitem), tonumber(params.quantity), text)
end)

add_processor("/inventory.php", function()
	if requestpath == "/inv_use.php" then
		used_spleen(tonumber(params.whichitem), 1, text:match([[<div id="effdiv">.-</div>]]))
	end
end)


add_printer("/charpane.php", function()
	local spleen = tostring(get_daily_counter("spleen"))
	if day["unknown spleen"] == "yes" then
		spleen = spleen .. "+?"
	end

	if compact_charpane then
		text = text:gsub([[(<hr width=50%%>.-)(</table><hr width=50%%><table align=center cellpadding=1 cellspacing=1>)]], function (a, b)
			local spleentext = ""
			if spleen ~= "0" then
				spleentext = [[<tr><td align=right>Spleen:</td><td align=left><b>]] .. spleen .. [[</b></td></tr>]]
			end
			if a:match(">Drunk:<") then
				return a:gsub([[(.-)(<tr><td align=right>Drunk:</td><td align=left><b>[0-9,]-</b></td></tr>)]], function (x, y)
					return x .. y .. spleentext
				end) .. b
			else
				return a .. spleentext .. b
			end
		end)
	end

	if normal_charpane then
		text = text:gsub([[^(.-)(<table cellpadding=3 align=center>)]], function (a, b)
			local spleentext = ""
			if spleen ~= "0" then
				local spleen_description = random_choice { "Spleen", "Melancholy", "Moroseness" }
				spleentext = [[<tr><td align=right>]] .. spleen_description .. [[:</td><td><b>]] .. spleen .. [[</b></td></tr>]]
			end
			if a:match("<tr><td align=right>[^<]-</td><td><b>[0-9,]-</b></td></tr>") then
				return a:gsub([[(.-)(<tr><td align=right>[^<]-</td><td><b>[0-9,]-</b></td></tr>)]], function (x, y)
					return x .. y .. spleentext
				end) .. b
			else
				return a:gsub("</table>$", function() return spleentext .. "</table>" .. b end)
			end
			return a .. b
		end)
	end
end)

-- TODO: warn when using frosty mug, divine champagne flute etc.
add_always_warning("/inv_booze.php", function()
	if buff("Ode to Booze") then return end
	function should_have_ode()
		if ascensionstatus() == "Aftercore" then
			return true
		end
		local pt = get_page("/skills.php")
		if pt:contains("Ode to Booze") then
			return true
		end
		return false
	end
	if should_have_ode() then
		return "You do not have Ode to Booze active", "drinking without ode"
	end
end)
