-- io = nil
os = nil
-- debug = nil
require = nil
module = nil
package = nil

if can_read_state() ~= "yes" then
	return text
end

dofile("scripts/base/util.lua")

input_params = params
params = parse_params(params)

local processors = {}

local function add_processor_raw(scriptname, file, func)
	if not processors[file] then processors[file] = {} end
	table.insert(processors[file], { scriptname = scriptname, f = func })
end

load_script_files {
	add_processor = function (file, func) add_processor_raw(name, file, func) end,
	add_printer = function () end,
	add_choice_text_conditional = function () end,
	add_choice_text = function () end,
	add_choice_itemtext = function () end,
	add_choice_function = function () end,
	add_interceptor = function () end,
	add_automator = function () end,
}

if requestpath == "/adventure.php" then
	zone = tonumber(requestquery:match("snarfblat=([0-9]+)"))
-- 	print("setting zone", zone)
	if (zone) then
		fight["zone"] = zone
		session["adventure.lastzone"] = zone
	end
end

setup_variables()
setup_functions()

-- if requestpath == "/adventure.php" and zone then
-- 	local encounter = nil
-- 	if monster_name then
-- 		encounter = monster_name
-- 	elseif adventure_result then
-- 		encounter = adventure_result
-- 	else
-- 		encounter = adventure_title
-- 	end
-- 	print("adventure in zone", zone, "got me", encounter, "   $$$$  %%% ", monster_name, adventure_title, adventure_result)
-- 	local tbl = get_ascension_state("zone-"..zone.."-encounters")
-- 	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
-- 	table.insert(tbl, encounter)
-- 	set_ascension_state("zone-"..zone.."-encounters", table_to_str(tbl))
-- end

do
	local semis = get_semirare_encounters()
	local function matches(x)
		if monster_name and new_fight_started then
			return monster_name:contains(x)
		elseif adventure_title == x or adventure_result == x then
			return true
		elseif text:contains(">There once was a bleary-eyed cyclops<") and x == "The Bleary-Eyed Cyclops" then -- HACK! The page for the cyclops eyedrops is weird
			return true
		else
			return false
		end
	end
	for x in tblvalues(semis) do
		if matches(x) then
			print("SEMIRARE!!!", x)
			set_ascension_state("fortune cookie numbers", "")
			set_ascension_state("last semirare encounter", x)
			set_ascension_state("last semirare turn", turnsthisrun())
		end
	end
end

run_functions(path, text, function (target, pt)
-- 	print("running processors for", target)
	for _, x in ipairs(processors[target] or {}) do
		getfenv(x.f).text = pt
		x.f()
	end
	return pt
end)

-- print(text)

return text
