add_interceptor("/trapper.php", function()
	if character["automate simple tasks"] ~= "yes" then return end
	if input_params == "[]" then
		local famid = familiarid()
		get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = 72 }) -- parrot
		text, url = get_page(path)
		get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = famid })
		return text, url
	end
end)


-- itznotyerzitz mine

add_choice_text("A Flat Miner", { -- choice adventure number: 18
	["Loot the dwarf's belongings"] = { getitem = "miner's pants" },
	["Hijack the Meat vein"] = { getitem = "7-Foot Dwarven mattock" },
	["Help the dwarf"] = { getmeat = 100 },
})

add_choice_text("100% Legal", { -- choice adventure number: 19
	["Demand loot"] = { getitem = "miner's helmet" },
	["Ask for ore"] = { getitem = "miner's pants" },
	["Say you'll keep quiet for free"] = { getmeat = 100 },
})

add_choice_text("See You Next Fall", { -- choice adventure number: 20
	["Give 'im the stick"] = { getitem = "miner's helmet" },
	["DOOOOON'T GIVE 'IM THE STICK!"] = { getitem = "7-Foot Dwarven mattock" },
	["Negotiate for a reward"] = { getmeat = 100 },
})

add_processor("/mining.php", function ()
	if not params.mine then return end
	if not text:contains("mining.php") then return end
	mine = params.mine:match("([0-9]+)")
	if mine then
		stateid = "mining.results." .. mine
		tbl = ascension[stateid] or {}
		tabletext = text:match([[<table cellpadding=0 cellspacing=0 border=0 background='http://images.kingdomofloathing.com/otherimages/mine/mine_background.gif'>(.-)</table>]])
		if not tabletext then return end
		local id = -1
		for celltext in tabletext:gmatch([[<td[^>]*>(.-)</td>]]) do
			id = id + 1
			image, title, height, width = celltext:match([[<img src='(http://images.kingdomofloathing.com/otherimages/mine/[a-z0-9]+.gif)' alt='[^']+' title='([^']+)' border=0 height=(50) width=(50)>]])
			if image then
				if image:match("wall1111.gif") or image:match("wallsparkle") then
					tbl[id] = nil
				end
			end
		end
		ascension[stateid] = tbl
	end
	which = query:match("which=([0-9]+)")
	resulttext = text:match([[<table *width=95%% *cellspacing=0 cellpadding=0><tr><td style="color: white;" align=center bgcolor=blue.-><b>Results:</b>(.-)<table *width=95%% *cellspacing=0 cellpadding=0><tr><td style="color: white;" align=center bgcolor=blue.-><b>]])
	if resulttext then
		img = resulttext:match([[<img src="http://images.kingdomofloathing.com/itemimages/([^"]+).gif"]])
		if mine and img then
			stateid = "mining.results." .. mine
			tbl = ascension[stateid] or {}
			tbl[tonumber(which)] = img
			ascension[stateid] = tbl
		end
	end
end)

add_processor("/trapper.php", function ()
	local wantore = text:match([[I reckon 3 chunks of ([a-z]-) ore oughta do the trick.]])
	if wantore then
		ascension["trapper.ore"] = wantore
	end
end)

add_printer("/mining.php", function ()
	if not params.mine then return end
	if not text:contains("mining.php") then return end
	mine = params.mine:match("([0-9]+)")
	if mine then
		stateid = "mining.results." .. mine
		tbl = ascension[stateid] or {}
	else
		tbl = {}
	end
	local best_which = nil
	local orechars = { aore = "a", core = "c", lore = "l", baconstone = "d" }
	local what_did_we_want = nil
	if mine == "1" and character["enable experimental implementations"] == "yes" then
		local what_do_we_want = nil
		if ascension["trapper.ore"] then
			local trapper_wants = { asbestos = "a", chrome = "c", linoleum = "l" }
			what_did_we_want = trapper_wants[ascension["trapper.ore"]]
			if count(ascension["trapper.ore"] .. " ore") < 3 then
				what_do_we_want = trapper_wants[ascension["trapper.ore"]]
			end
		end
		if what_do_we_want then
			local remap_id = {}
			local remap_id_inverse = {}
			for y = 0, 5 do
				for x = 1, 6 do
					remap_id[8 + y * 8 + x] = y * 6 + x
					remap_id_inverse[y * 6 + x] = 8 + y * 8 + x
-- 					print("remap", y * 6 + x, 8 + y * 8 + x)
				end
-- 				print("")
			end
			local x = text:match([[<table cellpadding=0 cellspacing=0 border=0 background='http://images.kingdomofloathing.com/otherimages/mine/mine_background.gif'>(.-)</table>]])
			local id = -1
			local curtbl = {}
			local can_mine_next = {}
			local already_mined = {}
			for celltext in x:gmatch([[<td[^>]*>(.-)</td>]]) do
				id = id + 1
				image, title, height, width = celltext:match([[<img src='(http://images.kingdomofloathing.com/otherimages/mine/[a-z0-9]+.gif)' alt='[^']+' title='([^']+)' border=0 height=(50) width=(50)>]])
				linkdata = celltext:match([[<a href='mining.php%?mine=[0-9]+&which=[0-9]+&pwd=[0-9a-f]+'>]])
				if image then
					if linkdata then
-- 						print("link", id, remap_id[id])
						can_mine_next[id] = true
						if title:contains("Promising") or image:contains("spark") then
							curtbl[id] = "?"
						else
							curtbl[id] = "."
						end
					else
						if tbl[id] then -- and alt == "Open Cavern" 
							curtbl[id] = orechars[tbl[id]] or "."
						elseif not image:match("wall1111.gif") and not image:match("wallsparkle") then
							already_mined[id] = true
							curtbl[id] = "."
						else
							curtbl[id] = "?"
						end
					end
				end
			end
			local curmine = ""
			for i_idx, i in ipairs({ 9, 10, 11, 12, 13, 14,
								17, 18, 19, 20, 21, 22,
								25, 26, 27, 28, 29, 30,
								33, 34, 35, 36, 37, 38}) do
				curmine = curmine .. curtbl[i]
			end
			if curmine:len() ~= 24 then
				error "Error parsing mine, did not find the 24 expected tiles"
			end
			print("curmine", curmine)
			local remappings = {}
			for a = 1, 4 do
				for c = 1, 4 do
					for l = 1, 4 do
						for d = 1, 4 do
							local newmap = {}
							local ores = "acld"
							newmap[ores:sub(a, a)] = "a"
							newmap[ores:sub(c, c)] = "c"
							newmap[ores:sub(l, l)] = "l"
							newmap[ores:sub(d, d)] = "d"
							newmap["."] = "."
							if newmap.a and newmap.c and newmap.l and newmap.d then
	-- 							print("newmap", table_to_str(newmap))
								table.insert(remappings, newmap)
							end
						end
					end
				end
			end
			local num_matches = 0
			local ores = {}
			for i = 1, 24 do
				ores[i] = { a = 0, c = 0, l = 0, d = 0, ["."] = 0 }
			end
			local function check(layout)
				for x = 1, curmine:len() do
					local want = curmine:sub(x, x)
					if want == "?" then
					elseif want == layout:sub(x, x) then
					else
						return false
					end
				end
-- 				print("..", layout)
				for x = 1, layout:len() do
					local y = layout:sub(x, x)
					ores[x][y] = ores[x][y] + 1
				end
				num_matches = num_matches + 1
				return true
			end
			local approx_distances = {}
			for xr, _ in pairs(can_mine_next) do
				local x = remap_id[xr]
				if x then
					approx_distances[x] = 0
				end
			end
			local function approx_min_distance(l, tile)
				local found = {}
				for x, _ in pairs(already_mined) do
					local c = remap_id[x]
					if c then
						if l:sub(c,c) == what_do_we_want then
							found[c] = true
						end
					end
				end
				local function get_xy(i)
					i = i - 1
					local y = math.floor(i / 6)
					local x = i - y * 6
					return x, y
				end
				local function mine_distance(a, b)
					x1, y1 = get_xy(a)
					x2, y2 = get_xy(b)
					return math.abs(x1 - x2) + math.abs(y1 - y2)
				end
				local nearest = 1000
				for x = 1, l:len() do
					local y = l:sub(x, x)
					if y == what_do_we_want and not found[x] then
						local dist = mine_distance(tile, x)
-- 						print("dist", x, table_to_str(found))
						nearest = math.min(nearest, dist)
					end
				end
-- 				print("nearest", nearest)
				return nearest
			end
			for l in io.lines("mine-layouts.txt") do
				for _, mapping in ipairs(remappings) do
					local l_remapped = ""
					for x = 1, l:len() do
						l_remapped = l_remapped .. mapping[l:sub(x,x)]
					end
					if check(l_remapped) then
						for xr, _ in pairs(can_mine_next) do
							local x = remap_id[xr]
-- 							print("xr", xr, remap_id[xr])
							if x then
-- 								print("approx", x, approx_min_distance(l_remapped, x))
								approx_distances[x] = approx_distances[x] + approx_min_distance(l_remapped, x)
							end
						end
					end
				end
			end
			for y = 0, 3 do
				local line = ""
				for x = 1, 6 do
					local c = y * 6 + x
					line = line .. string.format("%10.2f%%", ores[c][what_do_we_want] * 100.0 / num_matches)
				end
				print(line)
			end
			local best_dist = -1
			for y = 0, 5 do
-- 				local line = ""
				for x = 1, 6 do
					local c = y * 6 + x
					if approx_distances[c] then
						if (best_dist == -1 or approx_distances[c] < best_dist) and (approx_distances[c] >= 0 and approx_distances[c] < 1000000000) and (num_matches >= 20) then
							best_dist = approx_distances[c]
							best_which = remap_id_inverse[c]
						end
					end
-- 					line = line .. string.format("[%2d|%10d]", c, approx_distances[c] or -1)
				end
-- 				print(line)
			end
			print("best", best_which, best_dist)
		end
	end
	text = text:gsub("</head>", [[
<style>
	td.linkminecell:hover { background-color: rgba(150, 150, 150, 0.4); }
</style>
%0]])
	text = text:gsub([[(<table cellpadding=0 cellspacing=0 border=0 background='http://images.kingdomofloathing.com/otherimages/mine/mine_background.gif'>)(.-)(</table>)]], function(pre, tabletext, post)
		id = -1
		tabletext = tabletext:gsub([[<td[^>]*>(.-)</td>]], function(celltext)
			id = id + 1
			image, title, height, width = celltext:match([[<img src='(http://images.kingdomofloathing.com/otherimages/mine/[a-z0-9]+.gif)' alt='[^']+' title='([^']+)' border=0 height=(50) width=(50)>]])
			linkdata = celltext:match([[<a href='mining.php%?mine=[0-9]+&which=[0-9]+&pwd=[0-9a-f]+'>]])
			if image then
				if linkdata then
					local linkcolor = ""
					local linktext = ""
					local bgstyle = ""
					if title:contains("Promising") or image:contains("spark") then
						linkcolor = "lightgreen"
						linktext = "?"
					else
						linkcolor = "yellow"
						linktext = "x"
					end
					if best_which == id then
						if linkcolor == "lightgreen" then
							linkcolor = "green"
						end
						bgstyle = [[background-color: lightgreen;]]
					else
						bgstyle = [[background-image: url(']] .. image .. [['); background-repeat: no-repeat;]]
					end
					return [[<td class="linkminecell" style="height: ]] .. height .. [[px; width: ]] .. width .. [[px; ]] .. bgstyle .. [[">]] .. linkdata .. [[<center style="line-height: 50px;"><span style="color: ]] .. linkcolor .. [[;">]] .. linktext .. [[</span></center></a></td>]]
				else
					local background = [[background-image: url(']] .. image .. [['); background-repeat: no-repeat;]]
					if tbl[id] then -- and alt == "Open Cavern" 
						celldata = [[<center><img src="http://images.kingdomofloathing.com/itemimages/]] .. tbl[id] .. [[.gif"></center>]]
						if what_did_we_want and orechars[tbl[id]] == what_did_we_want then
							background = "background-color: green;";
						end
					else
--~ 						celldata = [[<center><span style="color: lightblue;">]] .. id .. [[</span></center>]]
						if title:contains("Promising") or image:contains("spark") then
							celldata = [[<center><span style="color: lightblue;">]] .. "?" .. [[</span></center>]]
						else
							celldata = [[<center><span style="color: lightblue;">]] .. "" .. [[</span></center>]]
						end
					end
					return [[<td class="minecell" style="height: ]] .. height .. [[px; width: ]] .. width .. [[px; ]] .. background .. [[">]] .. celldata .. [[</td>]]
				end
			else
				return false
			end
		end)
		return pre .. tabletext .. post
	end)
end)

-- goatlet

add_choice_text("Between a Rock and Some Other Rocks", { -- choice adventure number: 162
	["Help the miners clear the rocks away"] = "Unlock the goatlet",
	["Screw these rocks, I'm gonna roll out"] = { leave_noturn = true },
})

add_ascension_zone_check(60, function()
	if buff("On the Trail") then
		local trailed = retrieve_trailed_monster()
		if trailed ~= "dairy goat" then
			return "You are trailing '" .. tostring(trailed) .. "' when you might want to sniff a dairy goat."
		end
	end
end)

-- orc chasm

add_automator("/mountains.php", function()
	if character["automate simple tasks"] ~= "yes" then return end
	if params.orcs == "1" then
		if text:contains("you are unable to get past them") then
			text, url = post_page("/forestvillage.php", { pwd = params.pwd, action = "untinker", whichitem = get_itemid("abridged dictionary") })
			text, url = get_page("/mountains.php", params)
		end
	end
end)

-- mt. noob

add_automator("/tutorial.php", function()
	if character["automate simple tasks"] ~= "yes" then return end
	if params.action == "toot" then
		if text:contains("letter from King Ralph XI") then
			text, url = use_item_noajax("letter from King Ralph XI")
		end
	end
end)
